# This is a BitKeeper generated patch for the following project:
# Project Name: Linux kernel tree
# This patch format is intended for GNU patch command version 2.5 or higher.
# This patch includes the following deltas:
#	           ChangeSet	1.676.14.14 -> 1.676.14.15
#	  drivers/char/mem.c	1.16    -> 1.17   
#
# The following is the BitKeeper ChangeSet Log
# --------------------------------------------
# 02/09/27	bjorn_helgaas@hp.com	1.676.14.15
# drivers/char/mem.c: handle discontiguous memory when testing for
# noncached addresses.
# --------------------------------------------
#
diff -Nru a/drivers/char/mem.c b/drivers/char/mem.c
--- a/drivers/char/mem.c	Wed Oct  8 09:07:16 2003
+++ b/drivers/char/mem.c	Wed Oct  8 09:07:16 2003
@@ -177,6 +177,11 @@
 		  test_bit(X86_FEATURE_CYRIX_ARR, &boot_cpu_data.x86_capability) ||
 		  test_bit(X86_FEATURE_CENTAUR_MCR, &boot_cpu_data.x86_capability) )
 	  && addr >= __pa(high_memory);
+#elif defined(__ia64__)
+	struct page *page;
+
+	page = virt_to_page(__va(addr));
+	return !VALID_PAGE(page) || PageReserved(page);
 #else
 	return addr >= __pa(high_memory);
 #endif
